PROBLEM LINK:Author: Dmytro Berezin DIFFICULTY:SIMPLE PREREQUISITES:Basic Dynamic Programming PROBLEM:Given Frog's location on the X axis and they can communicate their message to another frog only if the distance are less than or equal to K , now you need to answer if given two frogs can communicate or not. Assumption : Frog's are cooperative in nature and will transfer the message without editing it :D . Quick ExplanationFind for each frog the maximum distance which his message can reach. Two Frogs can only communicate if their maximum distance of communication are same. ExplanationOnly Challenge left is to calculate the maximum distance which each frog can message. Using these observation , one can use a simple dp to calculate the maximum distance . But how ? Sort A[i]'s but do not loose the index of frog's while sorting. Let the sorted array be Frog[] . Now if Frog[i] can communicate to Frog[i+1] , then Frog[i] can communicate as mcuh distance as Frog[i+1] can communicate. Pseudo Code
Complexity: O(N*log(N)), N * logN for sorting N integers. AUTHOR'S and TESTER'S SOLUTIONS:Author's solution to be uploaded soon.
This question is marked "community wiki".
asked 14 Jul '14, 15:01
showing 5 of 18
show all

alternatively, make an another array containing indices, sort them using the first array. then assign some common number to those frogs who can communicate. ( In sample test case, indices becomes 0 1 3 2 4 and we have to check if v[1]v[0]<=k) if yes then assign some common value to them ). Link to code: http://ideone.com/nGyLo9 answered 14 Jul '14, 16:56

I solved the problem in two ways: Using Segment Trees, Using concept of connected component as pointed out by @brobear1995 But I haven't thought of a DP solution...I always miss out on DP.. :( answered 14 Jul '14, 17:10

Methodology Used: 1. Keep the input array 2. Create a duplicate array of it. 3. Sort the duplicate array. 4. Use the input index to get the element from original array, use Binary search ti find the index of that element in the duplicate sorted array. 5. Iterate through the starting index to the last index and check for <=K while iterating (a[i+1]a[i]<=K). 6. If reaches to the end, output Yes else No. 7. Giving WA.
answered 14 Jul '14, 20:29
1
I used the same methodology and got WA. Can someone tell what is wrong and provide test cases for which this method fails ???
(14 Jul '14, 23:19)
I used the same methodology and got AC. http://www.codechef.com/viewsolution/4186145 You should not check if it reaches the end, rather check if they reach the same block in the end. Its like finding out which islands they stay in. brobear has used the same approach.
(15 Jul '14, 16:59)

I copied the original array A into another array B and sorted it in increasing order, while maintaining the index.Then I copied the elements which fail the condition mentioned.
Then I used lower_bound to check the position of both the elements (A[x1],A[y1]) in the vector vec. If abs(posxposy)>=1, the answer will be no else it will be yes.
It worked. answered 15 Jul '14, 11:03

Hi , can u plz tell me for which Test case I am getting WA . http://www.codechef.com/viewsolution/4277673 Thanks rajesh answered 14 Jul '14, 16:44

Same thing I do but still getting TLE I sorted them using quick sort and then go through min coordinate to max coordinate and note down every starting point after breaking point say if coordinates are 0 8 5 3 12 and distance is 3 than i stored 0 12 in new array than i take input from user and get coordinate of there position and look for whether they belong to same interval or not if yes than answer is yes else no. Link to solution Please tell me what wrong in my code answered 14 Jul '14, 17:31

Sir, i have used this code and getting correct answer for all the test cases which i have tried....i am still getting WA...please help where is the error in the code?? http://www.codechef.com/viewsolution/4254933 answered 14 Jul '14, 17:33

Sir, I have used my code for most of the test cases and getting the desired output.....still I am getting WA....Kindly tell the respective cases for which my code was wrong....Thank you http://www.codechef.com/viewsolution/4297541 answered 14 Jul '14, 21:21
1
You are assuming that a[q1] < a[m1] which may not be true . Even if you are able to debug your code , You will get a TLE as the worst case complexity of your algorithm is O(N*P) where N <= 10^5 and P <= 10^5 .
(15 Jul '14, 16:30)

sir!! please tell me where my code goes wrong!! http://www.codechef.com/viewsolution/4330694 answered 14 Jul '14, 22:09

a simple one 
answered 15 Jul '14, 02:04

My code runs fine offline but does not run here http://www.codechef.com/viewsolution/4331567 answered 15 Jul '14, 02:58

Why can't we do it like this ?
answered 15 Jul '14, 04:52

I tried running it on my machine and it runs just fine for any input. gives errors when input is wrong and gives right answers as far as i've seen. can some1 point out the mistake in this please or the test cases for which my method fails. it took me about 6 hours to do this , since am new to java . Can some1 help me please... Thanks Solution >> http://www.codechef.com/viewsolution/4331737 answered 15 Jul '14, 05:47
Please put correct check on constraints. if(a[0]>=1 && a[0]<=100000) And further, you don't need to check the constraints.
(16 Jul '14, 16:09)

i solved it just like dp .but didnt realize it was a dp solution .first dp :P answered 15 Jul '14, 17:06

Please tell me why am I getting SIGSEGV so many times. I used a 2D vector info with representation as info[i][0]:xcoordinate info[i][1]:index of the frog info[i][2]:con variable i.e. if two frogs have same con then they are connected and can talk.Then I sorted this vector by the xcoordinate(ascending) and then I clustered them according to the condition that two adjacent frogs are in different cluster if their distance is more than K,then I created an array with element at index i being con of ith frog and then checked the input and if they have same con,"yes" else "no".I am continuously getting SIGSEGV even as the given test case and few other give right answer.I have tried declaring the vector as global variable but that doesn't help.Please tell me why am I getting SIGSEGV. I would be really thankful.Here's the link : http://www.codechef.com/viewsolution/4333207 answered 15 Jul '14, 18:16

Can anybody tell me why my code is giving WA ? Is my approach correct or not? Code: http://ideone.com/5YUtQY answered 18 Jul '14, 20:38

http://www.codechef.com/viewsolution/4343028 plz help me out . whats d problem in this solution ? answered 19 Jul '14, 01:30

Hi all, My solution is O(N*P) and will most likely get a TLE. But right now I am not able to figure out why it is giving a WA. The approach that I follow is :
Here's my code : http://www.codechef.com/viewsolution/4367483. Any testcase where this will give a WA would be greatly appreciated. Thanks ! answered 23 Jul '14, 00:22

Please help me http://www.codechef.com/viewsolution/4289736 I got WA for the above solution. Don't know where I am wrong. answered 27 Jul '14, 18:01

Can any expert out there help me with this solution. Its giving WA. I implemented pseudocode given in Editorial, but not working. : http://www.codechef.com/viewsolution/4405490 answered 30 Jul '14, 20:31

I am still getting wrong answer ..pls tell me where my code goes wrong... answered 09 Aug '14, 00:37

@all can u please provide the test case for which my code gave TLE?? http://www.codechef.com/viewsolution/4327814. I checked even the worst case but my code gave correct output within the time limit. Any suggestions for tricky test case ?? answered 18 Aug '14, 00:07

It can easily be done by using find and dp algo :p . 1) Just sort according to position (dont forgot to keep index). 2) iterate 1 to n and if distance is <= k then put index of second to index of first. 3) not whenever query is asked find parent ie fint which set they belong , if same > Yes else No. :) My code : http://ideone.com/UwJ1IX answered 27 Jun '15, 15:57

I solved using disjoint set data structure https://www.codechef.com/viewsolution/9496601 answered 27 Feb '16, 18:45

@devyug11 or any other expert, problem => passed the test case, now unable to identify where the problem is my approach => made 2 vectors, one storing the original input and other storing the input after sorting, then ,then iterated from starting frog to target frog in the sorted vector and kept checking that the consecutive distance is less then k my solution =>https://www.codechef.com/viewsolution/10092569 answered 16 May '16, 17:39
@gcs after writing this i read ur answer to that guy and found i was kind of using the same methodology, but wasn't able to understand what u were saying , can u please explain why cannot we iterate from the starting to the ending index can check v[i+1]v[i]<=k holds always true.
(16 May '16, 20:25)

For those who are solving treating frogs as nodes and are imagining an edge between two graphs , if they can communicate ; you need not use matrix or list to store the graph. You can find the different components as follows :
compo=1;
Link to the complete solution : https://www.codechef.com/viewsolution/12633965 answered 24 Jan '17, 16:56

it can be solved with unionfind method too and it's implementation is very easy.. answered 05 Apr '17, 14:46

`` codeblocks giving right answer every test case is satisfied answered 10 Apr '17, 18:19

It's simple just calculate the distance between every from...and if it is more than the value of k than the message can not be transferred answered 10 Apr '17, 23:03

It can also be done with the help of DSU data structure. answered 21 Oct '17, 22:06

Hello People, I have tried this problem almost 3 times with the logic give by @brobear1995 still get WA. Please help me out. Link to the solution. answered 23 Dec '17, 18:13

Can anyone tell me why the algorithm given below gives TLE..? let all a[i] form the nodes of an undirected graph. create a c++ set for all unvisited nodes.(initially containing all a[i]) initialize vis[] by all 1 now, call dfs for all nodes having vis[node]==1 & set vis[node]=caller function to ensure that vis[node] will have same value for all nodes forming a connected component. In dfs, recur for all nodes currently in unvisited(set) which have abs(a[i]node)<=k. Finally, for each query x and y: if(vis[x]==vis[y])>yes else>no answered 23 Jun '18, 00:55

sir i used the following logic which was giving me correct answer on ideone but i got 94 WA here.. :( kindly help..
answered 14 Jul '14, 15:23
Your code gives wrong answer for input:6 3 2 0 3 8 14 12 5 1 1 2 2 answer should be Yes Yes. And there is no need of printing the answers in the last.You can print them just after solving that particular case. :)
(14 Jul '14, 15:41)
sir!! please tell me where my code goes wrong!! http://www.codechef.com/viewsolution/4330694 passing even the teastcase u have given 6 3 2 0 3 8 14 12 5 1 1 2 2
(14 Jul '14, 22:16)

#include <iostream> include <algorithm>include <cstdlib>include <cmath>include<cstdio>using namespace std; int main() { int n,k,p,a[100001],c[100001],l,count=0,p1,p2,m=0,s,b=0,d=0; int i,j; scanf("%d %d %d",&n,&k,&p); for(i=0;i<n;i++) {="" scanf("%d",&a[i]);="" c[i]="a[i];" }="" sort(a,a+n);="" while(p)="" {="" scanf("%d="" %d",&p1,&p2);="" if(p1="=p2)" {printf("yes\\n");="" goto="" f;}="" p1="c[p11];" p2="c[p21];" b="(p1">=p2)?p1:p2; s=(p1<=p2)?p1:p2; for(i=0;i<n;i++) { if(b==a[i]) { for(m=l;m<i;m++) { if(a[m+1]a[m]<=k);else goto q; }goto y; } else if(a[i]==s) { l=i; } } q:;printf("No\n"); goto f; y:;printf("Yes\n"); f:; } return(0); } Its complexity is around nlogn...why its showing then Time limit exceeded? It used the same concept then why its showing TLE!!! This code can also be found at http://www.codechef.com/viewsolution/4327427 answered 14 Jul '14, 16:28

I know i solved it with more complexity added but i have used the Segment tree . http://www.codechef.com/viewsolution/4217571
I did the problem using union find algorithm
In the editorial it is given as ,any two frogs which have same maximum distances can communicate with each other. i am not able to clearly understand this statement.for example let us take this sample test case:
5 1 1
0 1 5 6 8
2 4
the second frog has a max distance of 1,and the fourth frog also has a maximum distance of 1.but they cant communicate with each other ...can sumone clarify??
@prem_93 : Maximum distance of communication of frog 2 is 1+1(=k) = 2 , whereas frog 4 has maximum distance of 6+1 = 7 , so they cannot communicate.
@devuy11 ...can u plz take the pain of explaining how max distance is calculated??
@prem_93 : There is no pain in explaining :D.Let's first sort each frog with it's XCordinate.Look closely at the last frog,he can communicate till Last_Frog_Position + K,Now look at the second last frog,If the message sent by the second last frog can reach last frog , then we can assume that the last frog will communicate the message of second last frog without editing :D , otherwise second_last_frog can send it up to second_last_frog position + K . Point to observe is that in calculation of maximum distance of second last frog , only last frog is needed . I hope you can extent it from here.
thnks that helped...i actually misunderstood the maximum distance of a specific frog as the maximum distamce itz message can reach..for example in the test case which i have given the fourth frog can transmit itz message over a maximum distance of 1 unit.but the max distance here the editorial specifies the maximum coordinate ...right....also my solution with complexity O(nlogn) is giving tle...how should i correct it??prob link: http://www.codechef.com/viewsolution/4319695
@prem_93 : right :) . Your code seems to be tough one for me to understand :( .
my algorithm is as follows:
1) used merge sort to sort the x coordinates.
2)after sorting, i found the points in which the communication path is disconnected.ie)the x coordinates for which , the distance between them and the next cordinate (in the sorted order) is greater than k. i stored these values in a new array callect disconnect.
3)now given x and y(nos of the frogs) i calculate their x coordinates and check if there is any value "v" in disconect array satisfying the condition:pos(x)<=v<pos(y)...if yes...then i output "no" and "Yes" if otherwise.
Please explain in a more readable manner. The English is sort of broken and I cannot understand the solution properly :(
1) i ued merge sort to sort the x coordinates.
2)then,i took the new sorted array and traversed through each element ,finding the elements for which this condition is satisfied: arr[i+1]arr[i]>k.i stored these in a new array (let it be p array).
3)now in each query I take in the values of x and y(frog nos),and find their respective positions(x coordinates)...let them be pos(x) and pos(y)...now i go through the "p" array and check if there is any value in it that satisfies this condition:pos(x)<=value<pos(y). if there is such a value the answer is "NO" and "YES" if otherwise.
For example: INPUT:
5 1 1
0 1 5 6 8
2 4
1)here after sorting the array is:0 1 5 6 8
2)in this case my "p" array would contain the elements 1 6..bcoz (51>k) and(86>k).
3) now in the query i have x=2,y=4...pos(2)=1 and pos(4)=6. now there is an element(1) in my p array which satisfies the condition 1<=1<6 and hence my answer would be "NO".
Hi, how do you prove by contradiction that both frogs can only communicate if they can reach the same maximal distance?
@kuruma  suppose frog at x coordinate = 1 can send message to maximum x=10, this means all frogs between x=1 and x=10 can send message to x=10. And this means frog at x=1 cannot send message to frog at x>10(because max distance he can send message is 10) .. And suppose frog at x=15 can send message to maximum x=20 and frog at x=10 is able to send message to x=15.. so the maximum distance frog at x=10 can send msg is x=20 and maximum distance frog at x=15 can send msg is x=20. that means frog at x=10 and x=15 can communicate (because all frog between x=10 and x=20 can communicate)
@kuruma
PROOFBYCONTRADICTION
STATEMENT:Twofrogs which have same maximal distances cannot communicate with each other.
let the common maximal distance be Y.
let position(frog'1') be a and pos(frog'2') be b.
letY>=b>=a.
Since,1stfrog can communicate till"Y",it should also mean that it can communicate to all the frogs whose positions are in the interval [a,Y].Since"b"is a position which satisfies this condition it can communicate with 2nd frog but this contradicts our statement and hence we have proved it false.
thus this proves that 2 frogs with same max distance can communicate.
@kuruma you can also prove the statement:
"Two frogs which have differnet maximal distances can communicate with each other." to be false in a similar way.
And from these 2 proofs you can conclude that "Two frogs can communicate with each other only if their maximal distances are the same."
@ShangJingbo and @GeraldAgapov can u please provide the test case for which my code gave TLE?? http://www.codechef.com/viewsolution/4327814
max distance= position of frog + k